#include <stdio.h>
#include <string.h>
#include <stdlib.h>

#include "../includes/open.h"  //Biblihotèque comprenant les fonctions nécessaire au chargement des fichiers
#include "../includes/close.h" //Biblihotèque comprenant les fonctions nécessaire à la libération de la mémoire
#include "../includes/Requete.h" //Biblihotèque comprenant les fonctions nécessaire à la réalisation des requetes



void affiche(struct cellule_airport * a)
{
  if (a==NULL) printf("tnul \n");
  while (a!=NULL)
    {
      printf("%s\n",a->info->IATA_CODE_AIRPORT);
      a=a->suiv;
    }
}


int main (void) //int argc, char *argv[]
{
  /////// Définition et ouverture des fichiers .csv ///////

  FILE* file_airports;
  FILE* file_flights;
  FILE* file_airlines;

  file_airports=fopen("data/airports.csv","r");
  file_flights=fopen("data/flights.csv","r");
  file_airlines=fopen("data/airlines.csv","r");

  printf("Ouverture des fichiers.. \n");

  if( (file_airports == NULL) || (file_flights == NULL) || (file_airlines == NULL) ){
    printf("Ouverture des fichiers impossible ! \n" );
    exit(0);
  }

  printf("Fichiers bien ouverts ! \n");

  /////// Définiton et chargement des données dans les SD ///////

  Hashtable Vols_Airline;
  init_ht(Vols_Airline);

  Hashtable Vols_Airport;
  init_ht(Vols_Airport);

  constr_flight_tab_airline(file_flights,Vols_Airline);
  constr_flight_tab_airport(file_flights,Vols_Airport);

  printf("Tables de hachages pour les vols bien construite\n");

  struct cellule_airport* Airports = calloc(1, sizeof(struct cellule_airport));
  struct cellule_airline* Airlines = calloc(1, sizeof(struct cellule_airline));

  Airports = NULL;
  Airlines = NULL;

  constr_airport_tab(file_airports,&Airports);
  printf("Liste des aéroports bien construite \n");

  constr_airline_tab(file_airlines,&Airlines);
  printf("Liste des compagnies aériennes bien construite \n");

  /*int q=1;    // Tant que q ("quitter") est != de 0, on lit les requêtes
   while (q==1)
     {

     }*/


  /////// On libère la mémoire ///////

  supp_ht_flight(Vols_Airline);
  supp_ht_flight(Vols_Airport);
  delete_airlines(&Airlines);
  delete_airports(&Airports);

  /////// On ferme les fichiers ///////

  fclose(file_airports);
  fclose(file_flights);
  fclose(file_airlines);

  return 0;
}
